---
  swagger: "2.0"
  info: 
    description: "This is a RESTFul API for Book online.\n"
    version: "1.0.0"
    title: "Book"
    contact: 
      name: "Frank Enrique Nicolau Gonzalez"
      url: "http://"
      email: "frank.nicolau03@gmail.com"
    license: 
      name: "Apache 2.0"
      url: "http://www.apache.org/licenses/LICENSE-2.0.html"
  schemes: 
    - "https"
  consumes: 
    - "application/json"
  produces: 
    - "application/json"
  security: 
    - 
      default: []
  paths: 
    /books: 
      get: 
        summary: "Get book by id"
        description: "Return book by id"
        consumes: 
          - "application/json"
        produces: 
          - "application/json"
        parameters: 
          - 
            name: "id"
            in: "query"
            description: "Id book"
            required: false
            type: "integer"
        responses: 
          200: 
            description: "A user object."
            headers: 
              Content-Type: 
                type: "string"
                description: "The content type of the body."
            schema: 
              type: "object"
              required: 
                - "autor"
                - "title"
                - "userName"
              properties: 
                id: 
                  type: "integer"
                  example: 38
                title: 
                  type: "string"
                  example: "WSO2 AM in Action"
                autor: 
                  type: "string"
                  example: "Frank E Nicolau Gonzalez"
                price: 
                  type: "number"
                  example: 38
                published: 
                  type: "integer"
                  example: 1
                userName: 
                  type: "string"
                  example: "frank"
                fileUri: 
                  type: "string"
                  example: "/frank/wso2inaction.pdf"
          404: 
            description: "Book not found"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 404
                msg: 
                  type: "string"
                  example: "Resource not found"
          500: 
            description: "Create Book error"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 500
                msg: 
                  type: "string"
                  example: "Internal server error"
        security: 
          - 
            default: []
        x-auth-type: "Application & Application User"
        x-throttling-tier: "Unlimited"
      post: 
        summary: "Create a new book"
        consumes: 
          - "application/json"
        produces: 
          - "application/json"
        parameters: 
          - 
            in: "body"
            name: "user"
            description: "The user to create."
            required: false
            schema: 
              type: "object"
              required: 
                - "autor"
                - "title"
                - "userName"
              properties: 
                id: 
                  type: "integer"
                  example: 38
                title: 
                  type: "string"
                  example: "WSO2 AM in Action"
                autor: 
                  type: "string"
                  example: "Frank E Nicolau Gonzalez"
                price: 
                  type: "number"
                  example: 38
                published: 
                  type: "integer"
                  example: 1
                userName: 
                  type: "string"
                  example: "frank"
                fileUri: 
                  type: "string"
                  example: "/frank/wso2inaction.pdf"
        responses: 
          201: 
            description: "Created. Successful response with the newly created object as entity in the body"
            headers: 
              Content-Type: 
                type: "string"
                description: "The content type of the body."
            schema: 
              type: "object"
              required: 
                - "autor"
                - "title"
                - "userName"
              properties: 
                id: 
                  type: "integer"
                  example: 38
                title: 
                  type: "string"
                  example: "WSO2 AM in Action"
                autor: 
                  type: "string"
                  example: "Frank E Nicolau Gonzalez"
                price: 
                  type: "number"
                  example: 38
                published: 
                  type: "integer"
                  example: 1
                userName: 
                  type: "string"
                  example: "frank"
                fileUri: 
                  type: "string"
                  example: "/frank/wso2inaction.pdf"
          500: 
            description: "Create Book error"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 500
                msg: 
                  type: "string"
                  example: "Internal server error"
        security: 
          - 
            default: []
        x-auth-type: "Application & Application User"
        x-throttling-tier: "Unlimited"
      put: 
        summary: "Update an existing book"
        consumes: 
          - "application/json"
        produces: 
          - "application/json"
        parameters: 
          - 
            in: "body"
            name: "book"
            description: "The book to update."
            required: false
            schema: 
              type: "object"
              required: 
                - "autor"
                - "title"
                - "userName"
              properties: 
                id: 
                  type: "integer"
                  example: 38
                title: 
                  type: "string"
                  example: "WSO2 AM in Action"
                autor: 
                  type: "string"
                  example: "Frank E Nicolau Gonzalez"
                price: 
                  type: "number"
                  example: 38
                published: 
                  type: "integer"
                  example: 1
                userName: 
                  type: "string"
                  example: "frank"
                fileUri: 
                  type: "string"
                  example: "/frank/wso2inaction.pdf"
        responses: 
          200: 
            description: "OK. Successful response with updated Book"
            headers: 
              Content-Type: 
                type: "string"
                description: "The content type of the body."
            schema: 
              type: "object"
              required: 
                - "autor"
                - "title"
                - "userName"
              properties: 
                id: 
                  type: "integer"
                  example: 38
                title: 
                  type: "string"
                  example: "WSO2 AM in Action"
                autor: 
                  type: "string"
                  example: "Frank E Nicolau Gonzalez"
                price: 
                  type: "number"
                  example: 38
                published: 
                  type: "integer"
                  example: 1
                userName: 
                  type: "string"
                  example: "frank"
                fileUri: 
                  type: "string"
                  example: "/frank/wso2inaction.pdf"
          404: 
            description: "Book not found"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 404
                msg: 
                  type: "string"
                  example: "Resource not found"
          500: 
            description: "Create Book error"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 500
                msg: 
                  type: "string"
                  example: "Internal server error"
        security: 
          - 
            default: []
        x-auth-type: "Application & Application User"
        x-throttling-tier: "Unlimited"
    /books/{id}: 
      delete: 
        summary: "Delete an existing book"
        description: "Delete book by id"
        consumes: 
          - "application/json"
        produces: 
          - "application/json"
        parameters: 
          - 
            name: "id"
            in: "path"
            required: true
            type: "integer"
        responses: 
          200: 
            description: "OK. Resource successfully deleted"
            headers: 
              Content-Type: 
                type: "string"
                description: "The content type of the body."
            schema: 
              type: "object"
              properties: 
                text: 
                  type: "string"
                  example: "Removed book with id 1"
          404: 
            description: "Book not found"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 404
                msg: 
                  type: "string"
                  example: "Resource not found"
          500: 
            description: "Internal server error"
            schema: 
              type: "object"
              properties: 
                code: 
                  type: "integer"
                  example: 500
                msg: 
                  type: "string"
                  example: "Internal server error"
        security: 
          - 
            default: []
        x-auth-type: "Application & Application User"
        x-throttling-tier: "Unlimited"
  securityDefinitions: 
    default: 
      type: "oauth2"
      authorizationUrl: "https://test.com"
      flow: "implicit"
  definitions: 
    Msg: 
      type: "object"
      properties: 
        text: 
          type: "string"
          example: "Removed book with id 1"
    Book: 
      type: "object"
      required: 
        - "autor"
        - "title"
        - "userName"
      properties: 
        id: 
          type: "integer"
          example: 38
        title: 
          type: "string"
          example: "WSO2 AM in Action"
        autor: 
          type: "string"
          example: "Frank E Nicolau Gonzalez"
        price: 
          type: "number"
          example: 38
        published: 
          type: "integer"
          example: 1
        userName: 
          type: "string"
          example: "frank"
        fileUri: 
          type: "string"
          example: "/frank/wso2inaction.pdf"
    Error: 
      type: "object"
      properties: 
        code: 
          type: "integer"
          example: 404
        msg: 
          type: "string"
          example: "Resource not found"
    fault: 
      type: "object"
      properties: 
        code: 
          type: "integer"
          example: 900902
        message: 
          type: "string"
          example: "Missing Credentials"
        description: 
          type: "string"
          example: "Invalid Credentials. Make sure your API invocation call has a header: ''Authorization : Bearer ACCESS_TOKEN'' or ''Authorization : Basic ACCESS_TOKEN'' or ''apikey: API_KEY"
  x-wso2-auth-header: "Authorization"
  x-throttling-tier: "Unlimited"
  x-wso2-cors: 
    corsConfigurationEnabled: true
    accessControlAllowOrigins: 
      - "*"
    accessControlAllowCredentials: false
    accessControlAllowHeaders: 
      - "authorization"
      - "Access-Control-Allow-Origin"
      - "Content-Type"
      - "SOAPAction"
    accessControlAllowMethods: 
      - "GET"
      - "PUT"
      - "POST"
      - "DELETE"
      - "PATCH"
      - "OPTIONS"
  x-wso2-production-endpoints: 
    urls: 
      - "http://localhost:8080/"
    type: "http"
  x-wso2-sandbox-endpoints: 
    urls: 
      - "http://localhost:8080/"
    type: "http"
  x-wso2-basePath: "/book/1.0.0"
  x-wso2-transports: 
    - "http"
    - "https"
